# African Swine Fever Management Model (asfmm)

Work in progress on the African Swine Fever (ASF) Management Model in [Go](https://go.dev) using the [Ark](https://github.com/mlange-42/ark) Entity Component System (ECS).

This will be an Ark implementation of a spatially explicit, stochastic simulation framework for modeling ASF transmission and evaluating control strategies in domestic pig herds.

The initial implementation process is based on the Classical Swine Fever Management Model [CSFMM](https://www.ecoepi.eu/CSFMM/), developed by Hans-Hermann Thulke, Dirk Eisinger and Martin Beer.

## Usage

To get started:

1. **Install Go:** 

    Ensure that you have Go installed on your system. You can download it from the official [Go website](https://golang.org/dl/).

2. **Clone the Repository:**  

    Open your terminal and clone the repository by executing the following command:
    ```
    git clone https://git.ufz.de/ecoepi/asfmm
    ```

3. **Run modell**  

    Navigate to the cloned repository folder and run the model by entering:
    ```
    go run .
    ```
    This will run the model with a default parameterization. 

## State of Development and Current Features

- The model distributes Finisher, Sow and Piglet herds within a square area
- a map visualization shows the locations of the herds within the area (Finisher: white, Sow: cyan, Piglet: blue) 


