package comps

import "github.com/mlange-42/ark/ecs"

// HerdType represents the type of herd in the simulation.
type HerdType uint8

// HerdType has three types
const (
	Finisher HerdType = iota
	Sow
	Piglet
	NumHerdTypes
)

// DiseaseStatus represents the disease status of a herd.
type DiseaseStatus uint8

// DiseaseStatus represents the disease status of a herd.
const (
	Susceptible DiseaseStatus = iota
	Exposed
	Infectious
	NumDiseaseStatus
)

// HerdDiseaseStatus contains the disease status of a herd.
type HerdDiseaseStatus struct {
	Status         DiseaseStatus
	TickOfExposure uint64
	DaysIncubated  uint8
}

// HerdPosition represents the position of a herd in the simulation.
type HerdPosition struct {
	X float64
	Y float64
}

// HerdID represents a unique identifier for a herd.
// TODO: HerdID necessary at all in model?
type HerdID struct {
	Value int
}

// HerdStock contains information about the pigs currently present in a herd.
type HerdStock struct {
	NumPigs int
	Type    HerdType
}

// LinkedHerd represents a linked herd entity (same farm).
type LinkedHerd struct {
	Herd ecs.Entity
}
