package main

import (
	"testing"

	"git.ufz.de/ecoepi/asfmm/comps"
	"git.ufz.de/ecoepi/asfmm/params"
	"git.ufz.de/ecoepi/asfmm/sys"
	"github.com/mlange-42/ark-tools/app"
	"github.com/mlange-42/ark-tools/system"
	"github.com/mlange-42/ark/ecs"
	"github.com/stretchr/testify/assert"
)

func TestInitHerds(t *testing.T) {

	model := app.New() //.Seed(42)
	model.AddSystem(&sys.InitHerds{})
	model.AddSystem(&system.FixedTermination{Steps: 1})

	p := params.DefaultParams()
	ecs.AddResource(&model.World, &p)

	model.Run()

	// TODO: ID necessary at all in model?
	farmFilter := ecs.NewFilter1[comps.HerdID](&model.World)
	query := farmFilter.Query()

	//query = farmFilter.Query()
	seenIDs := make(map[int]bool)
	for query.Next() {
		id := query.Get()

		_, keyExists := seenIDs[id.Value]
		assert.Falsef(t, keyExists, "Duplicate ID found: %d", id.Value)

		seenIDs[id.Value] = true
	}

}
